//
//  RCConversationController.m
//  RCIMKitDemo
//
//  Created by zhiheng on 2018/7/9.
//  Copyright © 2018年 com.wc. All rights reserved.
//

#import "RCConversationController.h"


@interface RCConversationController ()

@end

@implementation RCConversationController

- (id)init {
    self = [super init];
    if (self) {
        //设置要显示的会话类型
        [self setDisplayConversationTypes:@[
                                            @(ConversationType_PRIVATE), @(ConversationType_DISCUSSION), @(ConversationType_APPSERVICE),
                                            @(ConversationType_PUBLICSERVICE), @(ConversationType_GROUP), @(ConversationType_SYSTEM)
                                            ]];
        
        //聚合会话类型
        [self setCollectionConversationType:@[ @(ConversationType_SYSTEM) ]];
    }
    return self;
}


- (void)viewDidLoad {
    [super viewDidLoad];

    self.edgesForExtendedLayout = UIRectEdgeBottom;
    self.conversationListTableView.tableFooterView = [UIView new];
        // Do any additional setup after loading the view.
}
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    self.tabBarController.navigationItem.title = NSLocalizedString(@"app.conversion", @"Chat");
}
- (void)willDisplayConversationTableCell:(RCConversationBaseCell *)cell atIndexPath:(NSIndexPath *)indexPath
{
    
}
//重写RCConversationListViewController的onSelectedTableRow事件
- (void)onSelectedTableRow:(RCConversationModelType)conversationModelType
         conversationModel:(RCConversationModel *)model
               atIndexPath:(NSIndexPath *)indexPath {
//    RCConversationViewController *conversationVC = [[RCConversationViewController alloc]init];
//    conversationVC.conversationType = model.conversationType;
//    conversationVC.targetId = model.targetId;
//    conversationVC.title = @"想显示的会话标题";
//    [self.navigationController pushViewController:conversationVC animated:YES];
    if (model.conversationModelType == RC_CONVERSATION_MODEL_TYPE_PUBLIC_SERVICE) {
        RCConversationViewController *_conversationVC = [[RCConversationViewController alloc] init];
        _conversationVC.conversationType = model.conversationType;
        _conversationVC.targetId = model.targetId;
       // _conversationVC.userName = model.conversationTitle;
        _conversationVC.title = model.conversationTitle;
//        _conversationVC.conversation = model;
        [self.navigationController pushViewController:_conversationVC animated:YES];
    }
    
    if (conversationModelType == RC_CONVERSATION_MODEL_TYPE_NORMAL) {
        RCConversationViewController *_conversationVC = [[RCConversationViewController alloc] init];
        _conversationVC.conversationType = model.conversationType;
        _conversationVC.targetId = model.targetId;
      //  _conversationVC.userName = model.conversationTitle;
        _conversationVC.title = model.conversationTitle;
//        _conversationVC.conversation = model;
        _conversationVC.unReadMessage = model.unreadMessageCount;
        _conversationVC.enableNewComingMessageIcon = YES; //开启消息提醒
        _conversationVC.enableUnreadMessageIcon = YES;
        if (model.conversationType == ConversationType_SYSTEM) {
          //  _conversationVC.userName = @"系统消息";
            _conversationVC.title = @"系统消息";
        }
//        if ([model.objectName isEqualToString:@"RC:ContactNtf"]) {
//            RCDAddressBookViewController *addressBookVC = [RCDAddressBookViewController addressBookViewController];
//            addressBookVC.needSyncFriendList = YES;
//
//            [self.navigationController pushViewController:addressBookVC animated:YES];
//            return;
//        }
        //如果是单聊，不显示发送方昵称
        if (model.conversationType == ConversationType_PRIVATE) {
            _conversationVC.displayUserNameInCell = NO;
        }
        [self.navigationController pushViewController:_conversationVC animated:YES];
    }
    
    //聚合会话类型，此处自定设置。
    if (conversationModelType == RC_CONVERSATION_MODEL_TYPE_COLLECTION) {
        
        RCConversationController *temp = [[RCConversationController alloc] init];
        NSArray *array = [NSArray arrayWithObject:[NSNumber numberWithInt:model.conversationType]];
        [temp setDisplayConversationTypes:array];
        [temp setCollectionConversationType:nil];
        temp.isEnteredToCollectionViewController = YES;
        [self.navigationController pushViewController:temp animated:YES];
    }
    
    //自定义会话类型
//    if (conversationModelType == RC_CONVERSATION_MODEL_TYPE_CUSTOMIZATION) {
//        RCConversationModel *model = self.conversationListDataSource[indexPath.row];
//        
//        if ([model.objectName isEqualToString:@"RC:ContactNtf"]) {
//            RCDAddressBookViewController *addressBookVC = [RCDAddressBookViewController addressBookViewController];
//            [self.navigationController pushViewController:addressBookVC animated:YES];
//        }
//    }

}

@end
