//
//  RCUserCardCell.m
//  RCIMKitDemo
//
//  Created by zhiheng on 2018/7/10.
//  Copyright © 2018年 com.wc. All rights reserved.
//

#import "RCUserCardCell.h"

#import "RCDUtilities.h"
#import <RongIMKit/RongIMKit.h>
#import <SDWebImage/UIImageView+WebCache.h>




@interface RCUserCardCell()

@property(nonatomic, strong) UIImageView *averImageV;
@property(nonatomic, strong) UILabel *nikeLabel;
@property(nonatomic, strong) UILabel *phoneLabel;
@end

@implementation RCUserCardCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    if(self = [super initWithStyle:style reuseIdentifier:reuseIdentifier])
    {
        [self configUI];
        [self configViewData];
    }
    return self;
}
- (void)setHighlighted:(BOOL)highlighted animated:(BOOL)animated{}
- (void)setSelected:(BOOL)selected animated:(BOOL)animated{}

- (void)configUI
{
    [self.contentView addSubview:self.averImageV];
    [self.contentView addSubview:self.nikeLabel];
    [self.contentView addSubview:self.phoneLabel];
    
    [self layoutUI];
}
- (void)configViewData
{
    NSString *portraitUrl = [RCIM sharedRCIM].currentUserInfo.portraitUri;
    if ([portraitUrl isEqualToString:@""]) {
        portraitUrl = [RCDUtilities defaultUserPortrait:[RCIM sharedRCIM].currentUserInfo];
    }
    if ([portraitUrl hasPrefix:@"http"] || [portraitUrl hasPrefix:@"file:"]) {
        [self.averImageV sd_setImageWithURL:[NSURL URLWithString:portraitUrl]];
    } else {
        self.averImageV.image = [UIImage imageNamed:portraitUrl];
    }
    self.nikeLabel.text = [RCIM sharedRCIM].currentUserInfo.name;
}
- (void)layoutUI
{
    [self.averImageV mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.centerY.mas_equalTo(self.contentView);
        make.leading.mas_equalTo(self.contentView).mas_offset(15);
        make.size.mas_equalTo(CGSizeMake(50, 50));
    }];
    [self.nikeLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.leading.mas_equalTo(self.averImageV.mas_trailing).mas_offset(12);
        make.top.mas_equalTo(self.averImageV).mas_offset(5);
    }];
    [self.phoneLabel mas_remakeConstraints:^(MASConstraintMaker *make) {
        make.leading.mas_equalTo(self.nikeLabel);
        make.bottom.mas_equalTo(self.averImageV.mas_bottom).mas_offset(-5);

    }];


}
#pragma mark -- layz init

- (UILabel *)phoneLabel
{
    if(!_phoneLabel)
    {
        _phoneLabel = [[UILabel alloc] init];
        _phoneLabel.textColor = [UIColor lightGrayColor];
        _phoneLabel.font = [UIFont systemFontOfSize:12.f];
    }
    return _phoneLabel;
}


- (UILabel *)nikeLabel
{
    if(!_nikeLabel)
    {
        _nikeLabel = [[UILabel alloc] init];
        _nikeLabel.textColor = [UIColor blackColor];
        _nikeLabel.font = [UIFont systemFontOfSize:14.f];
    }
    return _nikeLabel;
}

- (UIImageView *)averImageV
{
    if(!_averImageV)
    {
        _averImageV = [[UIImageView alloc] init];
        _averImageV.contentMode = UIViewContentModeScaleAspectFill;
    }
    return _averImageV;
}
@end
