//
//  RCLanguageSettingController.m
//  RCIMKitDemo
//
//  Created by zhiheng on 2018/7/10.
//  Copyright © 2018年 com.wc. All rights reserved.
//

#import "RCLanguageSettingController.h"
#import "AppDelegate.h"



#import "RCLanguageConfig.h"
#import "NSBundle+RCUtils.h"

@interface RCLanguageSettingController ()<UITableViewDelegate,UITableViewDataSource>
@property(nonatomic, strong) UITableView *tableView;

@property(nonatomic, strong) NSArray *languages;

@end

@implementation RCLanguageSettingController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
      self.navigationItem.title = NSLocalizedString(@"mine.setting", @"no setting");
    self.languages = @[NSLocalizedString(@"app.systemLanguge", @"System default setting"),NSLocalizedString(@"app.chinneseLanguge", @"Chinese"),NSLocalizedString(@"app.englishLanguge", @"English")];
    [self configUI];
}
- (void)configUI
{    
    [self.view addSubview:self.tableView];
    
    //layout UI
    [self layoutUI];
}

- (void)layoutUI
{
    [self.tableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.edges.mas_equalTo(self.view);
    }];
}
#pragma mark --  tableView dataSource & delegate
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.languages.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"CellId"];
    if(!cell)
    {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"CellId"];
    }
    cell.textLabel.text = self.languages[indexPath.row];
    //用户没有自己设置的语言，则跟随手机系统
    if (![RCLanguageConfig userLanguage].length) {
        cell.accessoryType = indexPath.row == 0 ? UITableViewCellAccessoryCheckmark : UITableViewCellAccessoryNone;
    } else {
        if([[RCLanguageConfig userLanguage] hasPrefix:RCChineseLanuage]){
            if (indexPath.row == 1) {
                cell.accessoryType = UITableViewCellAccessoryCheckmark;
            } else {
                cell.accessoryType = UITableViewCellAccessoryNone;
            }
        }else{
            if (indexPath.row == 2) {
                cell.accessoryType = UITableViewCellAccessoryCheckmark;
            } else {
                cell.accessoryType = UITableViewCellAccessoryNone;
            }
        }
    }

    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
    if (cell.accessoryType == UITableViewCellAccessoryCheckmark) {
        return;
    }
    for (UITableViewCell *acell in tableView.visibleCells) {
        acell.accessoryType = acell == cell ? UITableViewCellAccessoryCheckmark : UITableViewCellAccessoryNone;
    }
    if (indexPath.row == 0) {
        [RCLanguageConfig setLanguage:nil];
    } else if (indexPath.row == 1) {
        [RCLanguageConfig setLanguage:RCChineseLanuage];
    } else {
        [RCLanguageConfig setLanguage:RCEnglishLanuage];
    }
    //清空当前应用栈Controller以及Views，重置Appdelegate.rootController
     [[AppDelegate appDelegate] toMainTabAtIndex:1];
}
#pragma mark -- layz init

- (UITableView *)tableView
{
    if(!_tableView)
    {
        _tableView = [[UITableView alloc]initWithFrame:CGRectZero style:UITableViewStylePlain];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.tableFooterView = [UIView new];
    }
    return _tableView;
}
@end
