//
//  RCLanguageConfig.m
//  RCIMKitDemo
//
//  Created by zhiheng on 2018/7/10.
//  Copyright © 2018年 com.wc. All rights reserved.
//

#import "RCLanguageConfig.h"

static NSString *const RCUserLanguageKey = @"RCUserLanguageKey";

#define STANDARD_USER_DEFAULT  [NSUserDefaults standardUserDefaults]

@implementation RCLanguageConfig

+ (void)setLanguage:(NSString *)language
{
    //跟随手机系统
    if (!language.length) {
        [self resetSystemLanguage];
        return;
    }
    //用户自定义
    [STANDARD_USER_DEFAULT setValue:language forKey:RCUserLanguageKey];
    [STANDARD_USER_DEFAULT synchronize];

}
+ (NSString *)userLanguage
{
    return [STANDARD_USER_DEFAULT valueForKey:RCUserLanguageKey];
}

/**
 重置系统语言
 */
+ (void)resetSystemLanguage
{
    [STANDARD_USER_DEFAULT removeObjectForKey:RCUserLanguageKey];
    [STANDARD_USER_DEFAULT synchronize];
}

@end
